use std::marker::PhantomData;

pub trait Message: 'static + Clone + Send + Sync {}

impl<T> Message for T where T: 'static + Clone + Send + Sync {}

pub struct Orsb {}

impl Orsb {
    pub fn new() -> Self {
        todo!()
    }

    pub fn subscribe<T: Message>(&mut self) -> Subscription<T> {
        todo!()
    }

    pub fn advertise<T: Message>(&mut self) -> Publication<T> {
        todo!()
    }
}

#[derive(Clone, Debug)]
#[non_exhaustive]
pub enum RecvErr {
    Empty,
    Closed,
    Lagged,
}

pub struct Subscription<T> {
    _phantom: PhantomData<T>,
}

impl<T: Message> Subscription<T> {
    pub async fn recv_wait(&mut self) -> Result<T, RecvErr> {
        todo!()
    }

    pub fn recv(&mut self) -> Result<T, RecvErr> {
        todo!()
    }

    pub fn try_recv(&mut self) -> Result<T, RecvErr> {
        todo!()
    }
}

#[derive(Clone, Debug)]
#[non_exhaustive]
pub enum SendErr {
    NoListeners,
}

pub struct Publication<T> {
    _phantom: PhantomData<T>,
}

impl<T: Message> Publication<T> {
    pub fn send(&mut self) -> Result<T, SendErr> {
        todo!()
    }
}
